export default function calcLinksToDisplay(totalPages, currentPage, atBeginEnd, aroundCurrent, ellipsisMark) {
    var result = [];
    for (var page = 0; page < Math.min(atBeginEnd, totalPages); page++) {
        if (!result.includes(page))
            result.push(page);
    }
    if (result.length !== 0) {
        var lastInLinks = result[result.length - 1];
        if (lastInLinks < Math.max(currentPage - aroundCurrent, 0) - 1)
            result.push(ellipsisMark);
    }
    else if (Math.max(currentPage - aroundCurrent, 0) > 0)
        result.push(ellipsisMark);
    for (var page = Math.max(currentPage - aroundCurrent, 0); page <= Math.min(currentPage + aroundCurrent, totalPages - 1); page++) {
        if (!result.includes(page))
            result.push(page);
    }
    if (result.length !== 0) {
        var lastInLinks = result[result.length - 1];
        if (lastInLinks < Math.max(totalPages - atBeginEnd, 0) - 1
            && lastInLinks !== ellipsisMark) {
            result.push(ellipsisMark);
        }
    }
    for (var page = Math.max(totalPages - atBeginEnd, 0); page <= totalPages - 1; page++) {
        if (!result.includes(page))
            result.push(page);
    }
    return result;
}
